/* cl_nntest.c
 * ANDHILL (soccer client for Robocup97)
 * Tomohito Andou <andou@is.titech.ac.jp>
 * Tokyo Institute of Technology
 * Dept of Mathematical and Computing Sciences
 * Copyright (C) 1997 Tomohito Andou
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#include "cl_nn.h"
#include "client.h"

void rand_initialize(void)
{
  int x, y, r;

  my_Sx = random() % SMALL_X;
  my_Sy = random() % SMALL_Y;
  my_x = S2Lx(my_Sx);
  my_y = S2Ly(my_Sy);
  ball_ex = (random() % 1000) / 1000.0 * PITCH_LENGTH;
  ball_ey = (random() % 1000) / 1000.0 * PITCH_WIDTH;

  for (y=0; y<SMALL_Y; y++)
    for (x=0; x<SMALL_X; x++) {
      r = random() % 20;
      if (r == 0)       map_char[x][y] = 5;
      else if (r == 1)  map_char[x][y] = 6;
      else              map_char[x][y] = 0;
    }
}

void main(int argc, char **argv)
{
  int i;
  srandom(time(0));

  learn_flag		= 1;
  output_flag		= 0x22;
  test_flag		= 1;
  posi_rand_init(0);

  initialize(); 
  posi_init();
  posi_output(stdout);
  for (i=0; i<=3000; i++) {
    rand_initialize();
    printf("test learning : %d\n", i);
    position();
#if 1
    if ((po_i[1] <= 0.0 && po_i[2] > 0.0) || 
	(po_i[1] > 0.0 && po_i[2] <= 0.0))
#else
    if (po_i[1] <= 0.0 && po_i[2] > 0.0)
#endif
      {
	reward(1.0);
	/*posi_reward(1.0, 0);*/
      }
#if 1
    else {
	reward(-1.0);
	/*posi_reward(1.0, 1);*/
      }
#endif
  }
  posi_output(stdout);
}

/* End Of File */
